Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Static Public Member Functions | List of all members
Botan::TPM_PrivateKey Class Referencefinal

`#include <tpm.h>`

Inheritance diagram for Botan::TPM_PrivateKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool) const override
virtual std::unique_ptr< PK_Ops::Decryption > | create_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Decryption > | create_kem_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Key_Agreement > | create_key_agreement_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Signature > | create_signature_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const
TPM_Context & | ctx () const
virtual Signature_Format | default_x509_signature_format () const
size_t | estimated_strength () const override
std::vector< uint8_t > | export_blob () const
std::string | fingerprint (const std::string &alg) const
std::string | fingerprint_private (const std::string &alg) const
std::string | fingerprint_public (const std::string &alg="SHA-256") const
BigInt | get_e () const
BigInt | get_n () const
virtual OID | get_oid () const
TSS_HKEY | handle () const
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
virtual AlgorithmIdentifier | pkcs8_algorithm_identifier () const
secure_vector< uint8_t > | private_key_bits () const override
secure_vector< uint8_t > | private_key_info () const
std::unique_ptr< Public_Key > | public_key () const
std::vector< uint8_t > | public_key_bits () const override
std::string | register_key (TPM_Storage_Type storage_type)
virtual bool | stateful_operation () const
std::vector< uint8_t > | subject_public_key () const
| TPM_PrivateKey (TPM_Context &ctx, const std::string &uuid, TPM_Storage_Type storage_type)
| TPM_PrivateKey (TPM_Context &ctx, const std::vector< uint8_t > &blob)
| TPM_PrivateKey (TPM_Context &ctx, size_t bits, const char *key_password)

## Static Public Member Functions
static std::vector< std::string > | registered_keys (TPM_Context &ctx)

## Detailed Description

Definition at line 109 of file tpm.h.

## Constructor & Destructor Documentation

## ◆ TPM_PrivateKey() [1/3]

Botan::TPM_PrivateKey::TPM_PrivateKey | ( | TPM_Context & | ctx,
|  | size_t | bits,
|  | const char * | key_password
| ) |  |

Definition at line 204 of file tpm.cpp.

205 : m_ctx(ctx)
206 {
207 // TODO: can also do OAEP decryption via binding keys
208 // TODO: offer signing, binding (decrypt), or legacy (sign + decrypt) keys?
209
210 TSS_FLAG key_flags = bit_flag(bits) | TSS_KEY_VOLATILE | TSS_KEY_TYPE_SIGNING;
211
212 TSS_HKEY key;
213 TSPI_CHECK_SUCCESS(::Tspi_Context_CreateObject(m_ctx.handle(), TSS_OBJECT_TYPE_RSAKEY, key_flags, &key));
214
215 TSPI_CHECK_SUCCESS(::Tspi_SetAttribUint32(key, TSS_TSPATTRIB_KEY_INFO,
216 TSS_TSPATTRIB_KEYINFO_SIGSCHEME,
217 TSS_SS_RSASSAPKCS1V15_DER));
218
219 TSS_HPOLICY policy;
220 TSPI_CHECK_SUCCESS(::Tspi_Context_CreateObject(m_ctx.handle(), TSS_OBJECT_TYPE_POLICY, TSS_POLICY_USAGE, &policy));
221 set_policy_secret(policy, key_password);
222 TSPI_CHECK_SUCCESS(::Tspi_Policy_AssignToObject(policy, key));
223
224 TSPI_CHECK_SUCCESS(::Tspi_Key_CreateKey(key, ctx.srk(), 0));
225 m_key = key;
226 }
Botan::TPM_Context::handle
TSS_HCONTEXT handle() const
Definition: tpm.h:67
Botan::TPM_Context::srk
TSS_HKEY srk() const
Definition: tpm.h:68
Botan::TPM_PrivateKey::ctx
TPM_Context & ctx() const
Definition: tpm.h:145
TSPI_CHECK_SUCCESS
#define TSPI_CHECK_SUCCESS(expr)
Definition: tpm.cpp:68

## ◆ TPM_PrivateKey() [2/3]

Botan::TPM_PrivateKey::TPM_PrivateKey | ( | TPM_Context & | ctx,
|  | const std::string & | uuid,
|  | TPM_Storage_Type | storage_type
| ) |  |

Definition at line 229 of file tpm.cpp.

230 :
231 m_ctx(ctx),
232 m_uuid(uuid_str),
233 m_storage(storage_type)
234 {
235 const TSS_FLAG key_ps_type =
236 (m_storage == TPM_Storage_Type::User) ? TSS_PS_TYPE_USER : TSS_PS_TYPE_SYSTEM;
237
238 TSPI_CHECK_SUCCESS(::Tspi_Context_LoadKeyByUUID(m_ctx.handle(),
239 key_ps_type,
240 to_tss_uuid(m_uuid),
241 &m_key));
242 }
Botan::TPM_Storage_Type::User
@ User

## ◆ TPM_PrivateKey() [3/3]

Botan::TPM_PrivateKey::TPM_PrivateKey | ( | TPM_Context & | ctx,
|  | const std::vector< uint8_t > & | blob
| ) |  |

Definition at line 244 of file tpm.cpp.

245 : m_ctx(ctx)
246 {
247 TSPI_CHECK_SUCCESS(::Tspi_Context_LoadKeyByBlob(m_ctx.handle(), m_ctx.srk(), blob.size(),
248 const_cast<uint8_t*>(blob.data()),
249 &m_key));
250
251 //TSPI_CHECK_SUCCESS(::Tspi_Key_LoadKey(m_key, m_ctx.srk()));
252 }

## Member Function Documentation

## ◆ algo_name()

std::string Botan::TPM_PrivateKey::algo_name | ( |  | ) | const
| inline override virtual

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 170 of file tpm.h.

170{ return "RSA"; } // ???

## ◆ algorithm_identifier()

AlgorithmIdentifier Botan::TPM_PrivateKey::algorithm_identifier | ( |  | ) | const
| override virtual

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 347 of file tpm.cpp.

348 {
349 return AlgorithmIdentifier(get_oid(),
350 AlgorithmIdentifier::USE_NULL_PARAM);
351 }
Botan::AlgorithmIdentifier::USE_NULL_PARAM
@ USE_NULL_PARAM
Definition: asn1_obj.h:432
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53

References Botan::Public_Key::get_oid(), and Botan::AlgorithmIdentifier::USE_NULL_PARAM.

## ◆ check_key()

bool Botan::TPM_PrivateKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Definition at line 381 of file tpm.cpp.

382 {
383 return true; // TODO do a kat or pairwise check
384 }

## ◆ create_decryption_op()

std::unique_ptr< PK_Ops::Decryption > Botan::Private_Key::create_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ElGamal_PrivateKey, Botan::RSA_PrivateKey, and Botan::SM2_PrivateKey.

Definition at line 114 of file pk_keys.cpp.

117 {
118 throw Lookup_Error(algo_name() + " does not support decryption");
119 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Decryptor_EME::PK_Decryptor_EME().

## ◆ create_encryption_op()

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ElGamal_PublicKey, Botan::RSA_PublicKey, and Botan::SM2_PublicKey.

Definition at line 91 of file pk_keys.cpp.

94 {
95 throw Lookup_Error(algo_name() + " does not support encryption");
96 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

## ◆ create_kem_decryption_op()

std::unique_ptr< PK_Ops::KEM_Decryption > Botan::Private_Key::create_kem_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PrivateKey, and Botan::RSA_PrivateKey.

Definition at line 122 of file pk_keys.cpp.

125 {
126 throw Lookup_Error(algo_name() + " does not support KEM decryption");
127 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Decryptor::PK_KEM_Decryptor().

## ◆ create_kem_encryption_op()

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PublicKey, and Botan::RSA_PublicKey.

Definition at line 99 of file pk_keys.cpp.

102 {
103 throw Lookup_Error(algo_name() + " does not support KEM encryption");
104 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

## ◆ create_key_agreement_op()

std::unique_ptr< PK_Ops::Key_Agreement > Botan::Private_Key::create_key_agreement_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a key agreement operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::Curve25519_PrivateKey, Botan::DH_PrivateKey, and Botan::ECDH_PrivateKey.

Definition at line 138 of file pk_keys.cpp.

141 {
142 throw Lookup_Error(algo_name() + " does not support key agreement");
143 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Key_Agreement::PK_Key_Agreement().

## ◆ create_signature_op()

std::unique_ptr< PK_Ops::Signature > Botan::TPM_PrivateKey::create_signature_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a signature operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 453 of file tpm.cpp.

456 {
457 return std::unique_ptr<PK_Ops::Signature>(new TPM_Signing_Operation(*this, params));
458 }

## ◆ create_verification_op()

std::unique_ptr< PK_Ops::Verification > Botan::Public_Key::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_PublicKey, Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::Ed25519_PublicKey, Botan::GOST_3410_PublicKey, Botan::RSA_PublicKey, Botan::SM2_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 107 of file pk_keys.cpp.

109 {
110 throw Lookup_Error(algo_name() + " does not support verification");
111 }

References Botan::Public_Key::algo_name().

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op(), and Botan::PK_Verifier::PK_Verifier().

## ◆ ctx()

TPM_Context & Botan::TPM_PrivateKey::ctx | ( |  | ) | const
| inline

Definition at line 145 of file tpm.h.

145{ return m_ctx; }

Referenced by register_key(), and registered_keys().

## ◆ default_x509_signature_format()

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 125 of file pk_keys.h.

126 {
127 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
128 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:112
Botan::DER_SEQUENCE
@ DER_SEQUENCE
Definition: pk_keys.h:23
Botan::IEEE_1363
@ IEEE_1363
Definition: pk_keys.h:23

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

## ◆ estimated_strength()

size_t Botan::TPM_PrivateKey::estimated_strength | ( |  | ) | const
| override virtual

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 337 of file tpm.cpp.

338 {
339 return if_work_factor(key_length());
340 }
Botan::TPM_PrivateKey::key_length
size_t key_length() const override
Definition: tpm.cpp:342
Botan::if_work_factor
size_t if_work_factor(size_t bits)
Definition: workfactor.cpp:38

References Botan::if_work_factor(), and key_length().

## ◆ export_blob()

std::vector< uint8_t > Botan::TPM_PrivateKey::export_blob | ( |  | ) | const

Definition at line 369 of file tpm.cpp.

370 {
371 return get_obj_attr(m_ctx.handle(), m_key,
372 TSS_TSPATTRIB_KEY_BLOB,
373 TSS_TSPATTRIB_KEYBLOB_BLOB);
374 }

References Botan::TPM_Context::handle().

## ◆ fingerprint()

std::string Botan::Private_Key::fingerprint | ( | const std::string & | alg | ) | const
| inline inherited

Definition at line 215 of file pk_keys.h.

216 {
217 return fingerprint_private(alg); // match behavior in previous versions
218 }
Botan::Private_Key::fingerprint_private
std::string fingerprint_private(const std::string &alg) const
Definition: pk_keys.cpp:85

## ◆ fingerprint_private()

std::string Botan::Private_Key::fingerprint_private | ( | const std::string & | alg | ) | const
| inherited

Returns
  Hash of the PKCS #8 encoding for this key object

Definition at line 85 of file pk_keys.cpp.

86 {
87 return create_hex_fingerprint(private_key_bits(), hash_algo);
88 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Private_Key::private_key_bits().

Referenced by Botan::Certificate_Store_In_SQL::find_certs_for_key(), Botan::Certificate_Store_In_SQL::insert_key(), and Botan::Certificate_Store_In_SQL::remove_key().

## ◆ fingerprint_public()

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Public_Key::subject_public_key().

## ◆ get_e()

BigInt Botan::TPM_PrivateKey::get_e | ( |  | ) | const

Definition at line 325 of file tpm.cpp.

326 {
327 if(m_e == 0)
328 {
329 m_e = BigInt::decode(get_obj_attr(m_ctx.handle(), m_key,
330 TSS_TSPATTRIB_RSAKEY_INFO,
331 TSS_TSPATTRIB_KEYINFO_RSA_EXPONENT));
332 }
333
334 return m_e;
335 }
Botan::BigInt::decode
static BigInt decode(const uint8_t buf[], size_t length)
Definition: bigint.h:817

References Botan::BigInt::decode(), and Botan::TPM_Context::handle().

Referenced by public_key(), and public_key_bits().

## ◆ get_n()

BigInt Botan::TPM_PrivateKey::get_n | ( |  | ) | const

Definition at line 313 of file tpm.cpp.

314 {
315 if(m_n == 0)
316 {
317 m_n = BigInt::decode(get_obj_attr(m_ctx.handle(), m_key,
318 TSS_TSPATTRIB_RSAKEY_INFO,
319 TSS_TSPATTRIB_KEYINFO_RSA_MODULUS));
320 }
321
322 return m_n;
323 }

References Botan::BigInt::decode(), and Botan::TPM_Context::handle().

Referenced by key_length(), public_key(), and public_key_bits().

## ◆ get_oid()

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

## ◆ handle()

TSS_HKEY Botan::TPM_PrivateKey::handle | ( |  | ) | const
| inline

Definition at line 147 of file tpm.h.

147{ return m_key; }

## ◆ key_length()

size_t Botan::TPM_PrivateKey::key_length | ( |  | ) | const
| override virtual

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 342 of file tpm.cpp.

343 {
344 return get_n().bits();
345 }
Botan::BigInt::bits
size_t bits() const
Definition: bigint.cpp:304
Botan::TPM_PrivateKey::get_n
BigInt get_n() const
Definition: tpm.cpp:313

References Botan::BigInt::bits(), and get_n().

Referenced by estimated_strength().

## ◆ message_part_size()

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 123 of file pk_keys.h.

123{ return 0; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ message_parts()

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 112 of file pk_keys.h.

112{ return 1; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ pkcs8_algorithm_identifier()

virtual AlgorithmIdentifier Botan::Private_Key::pkcs8_algorithm_identifier | ( |  | ) | const
| inline virtual inherited

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Reimplemented in Botan::GOST_3410_PrivateKey, Botan::XMSS_WOTS_PrivateKey, and Botan::XMSS_WOTS_Addressed_PrivateKey.

Definition at line 204 of file pk_keys.h.

205 { return algorithm_identifier(); }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0

Referenced by Botan::Private_Key::private_key_info().

## ◆ private_key_bits()

secure_vector< uint8_t > Botan::TPM_PrivateKey::private_key_bits | ( |  | ) | const
| override virtual

Returns
  BER encoded private key bits

Implements Botan::Private_Key.

Definition at line 364 of file tpm.cpp.

365 {
366 throw TPM_Error("Private key export not supported for TPM keys");
367 }

## ◆ private_key_info()

secure_vector< uint8_t > Botan::Private_Key::private_key_info | ( |  | ) | const
| inherited

Returns
  PKCS #8 private key encoding for this key object

Definition at line 61 of file pk_keys.cpp.

62 {
63 const size_t PKCS8_VERSION = 0;
64
65 return DER_Encoder()
66 .start_cons(SEQUENCE)
67 .encode(PKCS8_VERSION)
68 .encode(pkcs8_algorithm_identifier())
69 .encode(private_key_bits(), OCTET_STRING)
70 .end_cons()
71 .get_contents();
72 }
Botan::Private_Key::pkcs8_algorithm_identifier
virtual AlgorithmIdentifier pkcs8_algorithm_identifier() const
Definition: pk_keys.h:204
Botan::SEQUENCE
@ SEQUENCE
Definition: asn1_obj.h:42
Botan::OCTET_STRING
@ OCTET_STRING
Definition: asn1_obj.h:38

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::OCTET_STRING, Botan::Private_Key::pkcs8_algorithm_identifier(), Botan::Private_Key::private_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::PKCS8::BER_encode(), Botan::PKCS8::BER_encode_encrypted_pbkdf_iter(), and Botan::PKCS8::BER_encode_encrypted_pbkdf_msec().

## ◆ public_key()

std::unique_ptr< Public_Key > Botan::TPM_PrivateKey::public_key | ( |  | ) | const

Returns a copy of the public key

Definition at line 376 of file tpm.cpp.

377 {
378 return std::unique_ptr<Public_Key>(new RSA_PublicKey(get_n(), get_e()));
379 }
Botan::TPM_PrivateKey::get_e
BigInt get_e() const
Definition: tpm.cpp:325

References get_e(), and get_n().

## ◆ public_key_bits()

std::vector< uint8_t > Botan::TPM_PrivateKey::public_key_bits | ( |  | ) | const
| override virtual

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 353 of file tpm.cpp.

354 {
355 std::vector<uint8_t> bits;
356 DER_Encoder(bits)
357 .start_cons(SEQUENCE)
358 .encode(get_n())
359 .encode(get_e())
360 .end_cons();
361 return bits;
362 }

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), get_e(), get_n(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

## ◆ register_key()

std::string Botan::TPM_PrivateKey::register_key | ( | TPM_Storage_Type | storage_type | ) |

If the key is not currently registered under a known UUID, generates a new random UUID and registers the key. Returns the access URL.

Definition at line 254 of file tpm.cpp.

255 {
256 if(!m_uuid.is_valid())
257 {
258 TPM_RNG rng(ctx()); // use system_rng or arg RNG& instead?
259 m_uuid = UUID(rng);
260 m_storage = storage_type;
261
262 const TSS_UUID key_uuid = to_tss_uuid(m_uuid);
263 const TSS_FLAG key_ps_type =
264 (storage_type == TPM_Storage_Type::User) ? TSS_PS_TYPE_USER : TSS_PS_TYPE_SYSTEM;
265
266 const TSS_UUID srk_uuid = TSS_UUID_SRK;
267
268 TSPI_CHECK_SUCCESS(::Tspi_Context_RegisterKey(m_ctx.handle(),
269 m_key,
270 key_ps_type,
271 key_uuid,
272 TSS_PS_TYPE_SYSTEM,
273 srk_uuid));
274
275 }
276
277 // Presumably we could re-register in the other store and same UUID
278 // Doesn't seem like what is desired most of the time here
279 if(storage_type != m_storage)
280 {
281 throw TPM_Error("TPM key " + m_uuid.to_string() +
282 " already registered with different storage type");
283 }
284
285 return format_url(m_uuid, m_storage);
286 }
Botan::UUID::is_valid
bool is_valid() const
Definition: uuid.h:61
Botan::UUID::to_string
std::string to_string() const
Definition: uuid.cpp:67

References ctx(), Botan::TPM_Context::handle(), Botan::UUID::is_valid(), Botan::UUID::to_string(), TSPI_CHECK_SUCCESS, and Botan::User.

## ◆ registered_keys()

std::vector< std::string > Botan::TPM_PrivateKey::registered_keys | ( | TPM_Context & | ctx | ) |
| static

Definition at line 288 of file tpm.cpp.

289 {
290 TSS_KM_KEYINFO2* key_info;
291 UINT32 key_info_size;
292
293 // TODO: does the PS type matter here at all?
294 TSPI_CHECK_SUCCESS(::Tspi_Context_GetRegisteredKeysByUUID2(ctx.handle(),
295 TSS_PS_TYPE_SYSTEM,
296 nullptr,
297 &key_info_size,
298 &key_info));
299
300 std::vector<std::string> r(key_info_size);
301
302 for(size_t i = 0; i != key_info_size; ++i)
303 {
304 r[i] = format_url(key_info[i].keyUUID, key_info[i].persistentStorageType);
305 }
306
307 // TODO: are we supposed to free this memory and if so how?
308 //TSPI_CHECK_SUCCESS(::Tspi_Context_FreeMemory(ctx.handle(), key_info));
309
310 return r;
311 }

References ctx(), Botan::TPM_Context::handle(), and TSPI_CHECK_SUCCESS.

## ◆ stateful_operation()

virtual bool Botan::Private_Key::stateful_operation | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::XMSS_PrivateKey.

Definition at line 188 of file pk_keys.h.

188{ return false; }

## ◆ subject_public_key()

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::BIT_STRING
@ BIT_STRING
Definition: asn1_obj.h:37

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

The documentation for this class was generated from the following files:

- src/lib/prov/tpm/tpm.h
- src/lib/prov/tpm/tpm.cpp